module renderer;

import dsfml.window.all;
import dsfml.system.all;
import dsfml.graphics.all;

import consumer;
import imagecache;

class Renderer {
    public RenderWindow app;
    public Cache cache;
    private Consumer[] consumers;
    
    this(char[] title, int width, int height, int depth=32) {
	this.app = new RenderWindow(VideoMode(width, height, depth), title);
	this.app.setFramerateLimit(40);

	this.cache = new Cache("."); // TODO
    }

    void add_consumer(Consumer consumer) {
	this.consumers ~= consumer;
    }

    /* start the mainloop */
    void mainloop() {
	Event evt;

	while(this.app.isOpened()) {
	    // handle all events
	    while(this.app.getEvent(evt)) {
		if (evt.Type == Event.EventType.CLOSED) {
		    this.app.close();
		}		    
	    }
	    // draw all
	    foreach(Consumer consumer; this.consumers) {
		consumer.draw();
	    }
	    // display all
	    this.app.display();
	}
    }
}
